package com.example;

import java.io.File;
import java.lang.reflect.Field;
import java.util.Arrays;

public class JNICall
{
	private boolean addLibraryPath = true;

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	public JNICall(String path)
	{
		File file = new File(path + "/dll/JNICall.dll");
		if (file.exists()) {
			path += "/dll";

			if (addLibraryPath) {
				try {
					addLibraryPath(path);
					System.loadLibrary("JNICall");
//					System.out.println("JNICall.dll is loaded");
				} catch (Exception e) {
					e.printStackTrace();
				}
			} else {
				try {
					setLibraryPath(path);
					System.loadLibrary("JNICall");
//					System.out.println("JNICall.dll is loaded");

				} catch (NoSuchFieldException e) {
					e.printStackTrace();
				} catch (SecurityException e) {
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				}
			}
		} else {
			System.err.println("JNICall.dll not found");
		}
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	public void setLibraryPath(String path) throws NoSuchFieldException,SecurityException,
		                                    IllegalArgumentException, IllegalAccessException	
	{
		System.setProperty("java.library.path", path);

	    // set sys_paths to null
		Field sysPathsField = ClassLoader.class.getDeclaredField("sys_paths");
		sysPathsField.setAccessible(true);
		sysPathsField.set(null, null);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	/**
	* Adds the specified path to the java library path
	*
	* @param pathToAdd the path to add
	* @throws Exception
	*/
	public void addLibraryPath(String pathToAdd) throws Exception
	{
	    final Field usrPathsField = ClassLoader.class.getDeclaredField("usr_paths");
	    usrPathsField.setAccessible(true);
	 
	    // get array of paths
	    final String[] paths = (String[])usrPathsField.get(null);
	 
	    // check if the path to add is already present
	    for (String path : paths) {
	        if(path.equals(pathToAdd)) {
	            return;
	        }
	    }
	    // add the new path
	    final String[] newPaths = Arrays.copyOf(paths, paths.length + 1);
	    newPaths[newPaths.length-1] = pathToAdd;
	    usrPathsField.set(null, newPaths);
	}	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
	public native int    doMultiply(int    val1, int    val2); 
	public native String doCombine (String str1, String str2); 
	public native String getMessage(String message); 
}
