package com.example;

import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class JNICallServlet extends HttpServlet
{
	private static final long serialVersionUID = 1L;
	private final String UTF8 = "UTF-8";
	private JNICall jniCall;

	protected void doGet(HttpServletRequest request, 
			             HttpServletResponse response) throws ServletException, IOException 
	{
		String action = request.getParameter("action").trim();
		if(action == null || "".equals(action))
			action = "undefined";

		if (jniCall == null) {
			ServletContext context = request.getSession().getServletContext();
			String path = context.getRealPath("/");
			System.out.println("path = " + path);
			loadJNICall(path);
		}
		String answer = "";
		if (jniCall != null) {
			try {
				if (action.equalsIgnoreCase("Multiply"))
					answer = "" + jniCall.doMultiply(12, 15);
				else if (action.equalsIgnoreCase("Concat"))
					answer = jniCall.doCombine("Hello, ", "world!");
				else if (action.equalsIgnoreCase("Message"))
					answer = jniCall.getMessage("java message");
			} catch (Exception e) {
				System.err.println (e.getMessage());
			}
		}
		response.setContentType("text/plain");

		OutputStream outStream = response.getOutputStream();
		outStream.write(answer.getBytes(UTF8));
	    outStream.flush();
	    outStream.close();
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private void loadJNICall(String path)
	{
		if (jniCall != null)
			return;
		jniCall = new JNICall(path);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
}
